# sendkeyboardevents

![Parralels](https://www.parallels.com/static/pl/fileadmin/res/img/navigation/pl-logo-dk.png)

## AppserverClient Command Line Interface

### sendkeyboardevents

sends keyboard events to the local system. This means that the keyboard events will affect both local and remote applications.

**Category: Sessions**

```
AppServerClientCLI sendkeyboardevents -events "38,72,1.38,72,129." [-wait 5000] [-delay 200]  
```

### Arguments

* **`events (mandatory)`** Keyboard events which are sent to the local system. See Notes.
* **`wait (optional)`** Wait for the specified number of milliseconds before sending the first event.
* **`delay (optional)`** Delay between each additional event specified in milliseconds.

### Return codes:

ok - Command was successful\
NotAvailable - Communication with the client backend failed, ensure that the client is running\
InvalidArgs - Some arguments are missing or invalid\
Exception - System problem

### Examples:

AppServerClientCLI sendkeyboardevents -events 38,72,129. -delay 141 // VK\_UP EXTENDED KEYUP\
AppServerClientCLI sendkeyboardevents -events 38,72,1. -delay 453 // VK\_UP EXTENDED

### Notes:

Can be used without any session running.\
Every event is made up as follows vkCode,scanCode,flags\
For more information look up SendInput Win32 API\
If you send multiple events in the same command, you need to separate them by a full stop.

### See also:

[sendkeys](/landing/ras-windows-cli-guide/v20/commands/sendkeys.md)\
[sendmouseevents](/landing/ras-windows-cli-guide/v20/commands/sendmouseevents.md)\
[getsessionsinfo](/landing/ras-windows-cli-guide/v20/commands/getsessionsinfo.md)\
[disconnectsession](/landing/ras-windows-cli-guide/v20/commands/disconnectsession.md)\
[uploadfile](/landing/ras-windows-cli-guide/v20/commands/uploadfile.md)\
[downloadfile](/landing/ras-windows-cli-guide/v20/commands/downloadfile.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.parallels.com/landing/ras-windows-cli-guide/v20/commands/sendkeyboardevents.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
